<?php
function txta_sd($dafnam, $txa, $wcnt) {
  $txa = str_replace("\r", '', $txa);

  $txar = preg_split('/\n\s/', $txa, 2, PREG_SPLIT_NO_EMPTY);
  if($dafnam == 'dabkrs' || $dafnam == 'dabkrss') {
    if(count($txar) == 2) {
      $txar2 = preg_split('/\n/', $txar[1], 2, PREG_SPLIT_NO_EMPTY);
      $txa = str_replace("\n", '\\n', $txar[0])."\n".str_replace("\n", '\\n', $txar2[0])."\n".str_replace("\n", '\\n', $txar2[1]);
    } else {
      $txa = '@err'.$wcnt."\n".'_'."\n".str_replace("\n", '\\n', $txa);
    }
  } else if($dafnam == 'dabruks' || $dafnam == 'examples') {
    if(count($txar) == 2) {
      $txa = str_replace("\n", '\\n', $txar[0])."\n".str_replace("\n", '\\n', $txar[1]);
    } else {
      $txa = '@err'.$wcnt."\n".str_replace("\n", '\\n', $txa);
    }
  }

  if($dafnam == 'dabkrss') {
    if(preg_match("/\n[\s]*_[\s]*\n/", $txa) == 1) {
      return '';
    }
  }

  $txa = str_replace('<', '＜', $txa);
  $txa = str_replace('>', '＞', $txa);
  $txa = preg_replace('/(\[m[0-9]+\]|\[[\*]\]|\[\/[\*]\])/', ' ', $txa);
  $txa = preg_replace('/(\[c red\]|\[c black\]|\[c green\]|\[c violet\]|\[c crimson\]|\[c brown\])/', '[c]', $txa);
  $txa = preg_replace('/\\\\([\[\]])/', '$1', $txa);
  $txa = str_replace('[/m]', ' \\n ', $txa);
  if($dafnam == 'dabruks') {
    $txa = preg_replace('/\\\\n[ ]*••[ ]*\\\\n/', '\\n *** \\n', $txa);
  }
  $txa = preg_replace('/\[b\]([ ]*[IV]+[ ,])/', '\\n•$1', $txa);
  $txa = preg_replace('/\[b\]([ ]*[IV]+[ ]*)\[\/b\]/', '\\n•$1\\n', $txa);
  $txa = preg_replace('/\[b\]([^\[\]\n\/]+)\[\/b\]/', '[$1]', $txa);
  $txa = str_replace('[/b]', ' \\n ', $txa);
  while(preg_match('/\\\\n[ ]*\\\\n/', $txa) == 1) {
    $txa = preg_replace('/\\\\n[ ]*\\\\n/', '\\n', $txa);
  }
  $txa = preg_replace('/[ ]{2,}/', ' ', $txa);
  $txa = preg_replace('/[ ]*\\\\n[ ]*/', '\\n', $txa);
  $txa = preg_replace('/(\\\\n| )*\n(\\\\n| )*/', "\n", $txa);
  $txa = preg_replace('/(\\\\n| )*$/', '', $txa);
  $txa = preg_replace('/^(\\\\n| )*/', '', $txa);
  $txa = preg_replace('/([\(\[])[ ]+/', '$1', $txa);
  $txa = preg_replace('/[ ]+([\)\]])/', '$1', $txa);
  if($dafnam == 'examples') {
    if(preg_match('/(\\\\n\\\\n.*)(\\\\n)+/', $txa) == 1) {
      $txa = str_replace('\\n\\n', '\\n', $txa);
    }
  }
  $txa = str_replace('[i]', '<i>', $txa);
  $txa = str_replace('[/i]', '</i>', $txa);
  $txa = str_replace('[c]', '<c c="green">', $txa);
  $txa = str_replace('[/c]', '</c>', $txa);
  $txa = str_replace('[p]', '<c c="green">', $txa);
  $txa = str_replace('[/p]', '</c>', $txa);
  $txa = str_replace('[ex]', '<ex>', $txa);
  $txa = str_replace('[/ex]', '</ex>', $txa);
  $txa = str_replace('[ref]', '<kref>', $txa);
  $txa = str_replace('[/ref]', '</kref>', $txa);
  return $txa;
}

function restfunc($dafnam, $wordcount, $wordcountall) {
  $wd = $wordcountall - $wordcount;
  $gs = '';
  if($wd != 0) $gs = ' (-'.strval($wd).')';
  return $dafnam.': '.strval($wordcount).$gs.'<br>';
}

function ucmp($a, $b) {
  $c = mb_strtolower($a);
  $d = mb_strtolower($b);
  if($c == $d) {
    if($a == $b) return 0;
    return ($a < $b) ? -1 : 1;
  }
  return ($c < $d) ? -1 : 1;
}

function convert_sd($dadir, $dafnam, $profdicarr, $dictitle, $dicdescr, $dadate, $testfl) {
$sd_dir = 'StarDict';
if(!is_dir($sd_dir)) {
  mkdir($sd_dir);
}
$ddir = $sd_dir.'/'.$dafnam;
if(!is_dir($ddir)) {
  mkdir($ddir);
}
$wordcountall = 0;
$wordcount = 0;
$fndict = $ddir.'/'.$dafnam.'.dict';
@unlink($fndict);
$hdictwrite = fopen($fndict, 'a');

$curoffset = 0;
$tarr = array();
$tarr['0_0'] = ' ';
foreach ($profdicarr as $dakey => $val) {
  $fnamerd = $dadir.$dakey.'_'.$dadate;
  if($dakey == 'dabkrss') {
    $fnamerd = str_replace('dabkrss', 'dabkrs', $fnamerd);
  }
  $fp = @fopen($fnamerd, 'r');
  if(!$fp) return 'err:'.$fnamerd;
  $lbuf = '';
  $wordc = 1;
  $buffer = fgets($fp);
  $buffer = fgets($fp);
  $buffer = fgets($fp);
  while (true) {
    $buffer = fgets($fp);
    if($buffer == "\r\n" || $buffer == "\n" || $buffer === false) {
      if($buffer === false && $lbuf == '') break;
      $lbuf = trim($lbuf);
      if($lbuf == '') continue;
      ++$wordcountall;
      $xtx = txta_sd($dakey, $lbuf, $wordcountall);
      if($xtx == '') {
        $lbuf = '';
        continue;
      }
      $ard = explode("\n", $xtx);
      foreach ($ard as &$val) $val = str_replace('\\n', "\n", $val);
      unset($val);

      if(strlen($ard[0]) > 253) {
        $ardk0 = mb_substr($ard[0], 0, 50).'...';
      } else $ardk0 = $ard[0];

      if($dakey == 'dabkrs' || $dakey == 'dabkrss') {
        $ard[1] .= "\n".$ard[2];
      }

      $ktl = fwrite($hdictwrite, '<k>'.$ard[0].'</k>'."\n".$ard[1]);
      $tarr[$curoffset.'_'.$ktl] = $ardk0;
      $curoffset += $ktl;
      ++$wordcount;
      $lbuf = '';
      if($testfl) {
        if($wordc >= $GLOBALS['tstnums']) break;
        else ++$wordc;
      }
    } else $lbuf .= $buffer;
  }
  fclose($fp);
}
fclose($hdictwrite);
uasort($tarr, 'ucmp');

$fnidx = $ddir.'/'.$dafnam.'.idx';
@unlink($fnidx);
$hidxwrite = fopen($fnidx, 'a');
foreach ($tarr as $key => $val) {
  $keyar = explode('_', $key);
  fwrite($hidxwrite, $val);
  fwrite($hidxwrite, pack('C',0), 1);
  fwrite($hidxwrite, pack('N',$keyar[0]), 4);
  fwrite($hidxwrite, pack('N',$keyar[1]), 4);
}
fclose($hidxwrite);
unset($tarr);

$fnifo = $ddir.'/'.$dafnam.'.ifo';
@unlink($fnifo);
$hifowrite = fopen($fnifo, 'a');
$search = array('@@wordcount@@', '@@idxfilesize@@', '@@dictitle@@', '@@date@@', '@@dicdescr@@');
$replace = array($wordcount, filesize($fnidx), $dictitle, date('Y.m.d',time()), $dicdescr);
$ifotext = 'StarDict\'s dict ifo file
version=2.4.2
wordcount=@@wordcount@@
idxfilesize=@@idxfilesize@@
bookname=@@dictitle@@
date=@@date@@
sametypesequence=x
description=@@dicdescr@@';

fwrite($hifowrite, str_replace($search, $replace, $ifotext));
fclose($hifowrite);
return restfunc($dafnam, $wordcount, $wordcountall);
}
?>